if (typeof Smc == "undefined"){
	window.Smc = {};
}

Smc.customInitExecuted = false;
Smc.SectionVariables = function() {
	return {
		variableValues : {
			'isOnlineHelp':'true',
		},
		setVariables : function(){
			$.each($('#sectionVariables').serializeArray(), function(i, field) {
				Smc.SectionVariables.variableValues[field.name] = field.value;
			});
		}
	}
}();
Smc.customInit = function () {
	var allExpanded = false;
	window.iframeLastHeight = [];
	window.lastCollapsible = null;
	window.isTesting = false;
	window.activatedLink = null;
	window.sidebarOverlayVisible = false;

	Smc.SectionVariables.setVariables();

	var data = Smc.SectionVariables.variableValues.data;
	var isTab = Smc.SectionVariables.variableValues.isTab == 'true';
	var isCollapse = Smc.SectionVariables.variableValues.isCollapse == 'true';
	var isContent = Smc.SectionVariables.variableValues.isContent == 'true';
	var rootPanelId = Smc.SectionVariables.variableValues.rootPanelId;
	var blockId = Smc.SectionVariables.variableValues.blockId;

	$('.bottom-tabs-content').addClass("hidden-tabs");
	var options = {
		//url: rootPath + "js/search.json",
		data: data,
		getValue: "topic",

		template: {
			type: "description",
			fields: {
				description: "title"
			}
		},

		list: {
			match: {
				enabled: true
			},
			onChooseEvent: function() {
				var selectedUrl = $("#data-links").getSelectedItemData().url;
				window.location.href = rootPath + selectedUrl;
			}
		},
		theme: "bootstrap"
	};

	/*
	var clock = $('#clock');
	if(clock.length){
		clock.countdown({until: clock.data('secondsDown'),format:'MS',layout: '{mnn}{sep}{snn}',});
	}
	*/
	$('[data-toggle="offcanvas"]').click(function () {
		$('.row-offcanvas').toggleClass('expanded');
	});

	$('.closeTabs').click(function(){
		var accordionId = $(this).data("accordionId"),
			numPanelOpen = $(accordionId + ' .collapse.in').length;

		if(accordionId != undefined){
			closeAllPanels(accordionId);
			$(this).addClass('closed');
			$(this).removeClass('opened');
		}
	});

	openAllPanels = function(aId) {
		$(aId + ' .panel-collapse:not(".in")').collapse('show');
		$('.bread-item.active').removeClass('active');
		/*var panels = $(aId + ' .panel-collapse');
		for (let p = 0; p < panels.length; p++) {
			const panel = panels[p];
			$(panel).collapse('show');
		}*/
	}
	closeAllPanels = function(aId) {
		$(aId + ' .panel-collapse.collapse.in').collapse('hide');
		allExpanded = false;
	}

	$('.tab-pagination-next').click(function(){
		var nextLi = $('.nav-tabs > .active').next('li');
		nextLi.find('a').trigger('click');
	});

	$('.tab-pagination-prev').click(function(){
		var prevLi = $('.nav-tabs > .active').prev('li');
		prevLi.find('a').trigger('click');
	});

	/**/
	function acceptLink(){
		//linkBehavior
		window.location.href = window.activatedLink;
	}
	var linkFunction = function(e){
		//collapsibleBehavior
		var collapseId = $(e.data.scope).data('collapsibleId');
		var collapsibleLink = $("a[aria-controls="+collapseId+"]");
		if(isCollapse && collapsibleLink.length > 0){
			e.preventDefault();
			if(collapsibleLink != undefined){
				collapsibleLink.trigger('click', [{becareful:true}]);
			}
		}else if(collapsibleLink.length==0){
			window.location.href = e.data.scope.href;
		}
	}

	var toCollapse = function(e){
		//it self collapse
		$(e.data.scope).trigger('click', [{becareful:true}]);
	}
	$('.isCollapsible').on('click', function(e, data) {
		//click behavior like collapsible
		e.preventDefault();
		if (window.isTesting) {
			openTestingModal(this, linkFunction);
			return false;
		} else {
			var collapsibleId = $(this).data('collapsibleId');
			// $('#'+collapsibleId).collapse('show');
			$("a[aria-controls=" + collapsibleId + "]").trigger('click');
		}
	});
	$('a').on('click', function(e, data){
		if ($(this).hasClass( "collapsed" ) && !(data && data.becareful)){
			//click behavior like collapse  (if collapsed and no care)
			if(window.isTesting){
				window.activatedLink = this.href;
				openTestingModal(this, toCollapse);
				return false;
			}
		}else if(!$(this).hasClass("collapsed") && !$(this).hasClass("infoButton") && !$(this).hasClass("popup")){
			//click behavior like link
			if(window.isTesting){
				window.activatedLink = this.href;
				openTestingModal(this, acceptLink);
				return false;
			}
		}
	});

	//Allow set max-heigth by characterization
	customMaxHeightForMedia();
	handledLinksxRef();

	//function confirmExitTest()
	function openTestingModal(scope, callback){
		//confirm test exit
		var modal = $('#testing-modal');
		var fClose = function(){
			modal.modal("hide");
		}
		modal.modal("show");
		$("#endTesting").unbind().one('click', {scope: scope}, callback).one('click', fClose);
	}


	$('.panel').on('hide.bs.collapse', function (e) {
		var menuButtonId = $(e.currentTarget).data('buttonId');
		var panelID = 'collapsible-' + $(e.currentTarget).data('panelId');
		$('#'+menuButtonId).parent().removeClass('active');
		$('#'+menuButtonId+'-bread').removeClass('active');
		var blockId = $(this).data('blockId');
		if ($("#"+blockId+"-timer-modal").data('ejecuted') === true){
			window.isTesting = false;
		}
		var clock = $('#clock');
		var clockBlockId = clock.data('blockId');
		//if(blockId == clockBlockId && window.isTesting)
		//showFeedback(clock);
		$(this).removeClass("floating");
		var openPanels = $('#'+panelID).find(".panel-heading.active");
		for(var i = 0; i < openPanels.length; i++){
			var openPanel = openPanels[i];
			var menuButtonId = $(openPanel).parent().data('buttonId');
			$('#'+menuButtonId+'-bread').removeClass('active');
		}

		if(window.sidebarOverlayVisible){
			$('#sidebar-nav-collapse').collapse('hide');
		}
	});

	$('.panel').on('hidden.bs.collapse', function (e) {
		var mainOpenPanels = $('#main-content-' + rootPanelId ).find(".panel-heading.active");
		if(mainOpenPanels.length == 0){
			var closeLink = $('.closeTabs');
			closeLink.removeClass('opened');
			closeLink.addClass('closed');
		};
	});

	$('.panel').on('show.bs.collapse', function (e) {
		var panel = this;
		var panelID = 'collapsible-' + $(e.currentTarget).data('panelId');
		var menuButtonId = $(e.currentTarget).data('buttonId');
		$('#'+menuButtonId).parent().addClass('active');
		if(!allExpanded) {
			$('#' + menuButtonId + '-bread').addClass('active');
			var slideStart = $(e.currentTarget).data('slideStart');
			if(Smc.SectionVariables.variableValues.isOnlineHelp != 'true'){
				if(slideStart !== undefined && slideStart > 0){
					window.location.hash=this.getAttribute("id")+"&"+slideStart;
				}else{
					window.location.hash=this.getAttribute("id");
				}
			}

		}

		var openPanels = $('#'+panelID).find(".panel-heading.active");
		for(var i = 0; i < openPanels.length; i++){
			var openPanel = openPanels[i];
			var menuButtonId = $(openPanel).parent().data('buttonId');
			if(!allExpanded){
				$('#'+menuButtonId+'-bread').addClass('active');
			}
		}

		if(!allExpanded){
			var parentClose = $(panel).parents(".panel")[0] ?
				$($(panel).parents(".panel")).children(".panel-heading:not(.active)") : null;

			if(parentClose){
				for(var i = 0; i < parentClose.length; i++){
					var panelHeading = parentClose[i];
					$(panelHeading).addClass('active');
					var closePanelId = $(panelHeading).parent().data('panelId');
					$('#collapsible-'+closePanelId).addClass('in');
					var menuButtonId = $(panelHeading).parent().data('buttonId');
					$('#'+menuButtonId).parent().addClass('active');
					$('#'+menuButtonId+'-bread').addClass('active');
				}
			}
			checkPanelsPosition();
		}

		if(window.sidebarOverlayVisible){
			$('#sidebar-nav-collapse').collapse('hide');
		}
	});

	$('.panel').on('shown.bs.collapse', function (e) {
		var blockId = $(this).data('blockId');
		if ($("#"+blockId+"-timer-modal").data('ejecuted') === true){
			window.location.reload(false);
		}
		var parentId = $(this).data('parentId');
		var slideStart = $(e.currentTarget).data('slideStart');
		checkTimer(blockId, true, $(this).position().top + 120);
		if(slideStart > 0)
			$("#carousel-" + this.getAttribute("id") + "-tab").carousel(Number(slideStart));
		// if(window.lastCollapsible != null){
		// 	var lastHeader = $(window.lastCollapsible).find(".panel-heading")[0];
		// 	$(lastHeader).css("top",'');
		// }
		window.lastCollapsible = this;

		var closeLink = $('.closeTabs');
		closeLink.addClass('opened');
		closeLink.removeClass('closed');
		if(!allExpanded){
			$('html, body').animate({
				scrollTop: $(this).offset().top
			}, 0);
		}
		e.stopPropagation();

		//setPadding(this);
		//this.scrollIntoView({block: "start", behavior: "smooth"});
	});

	function setPadding(currentPanel){
		var panelHeight = $(currentPanel).height();
		var windowHeight = $(window).height();
		var panelGroupHeight = $(currentPanel).parent().height();
		var TopHeight = $(window).scrollTop();
		var newPadding = windowHeight - panelHeight;
		if(newPadding > 0){
			$(currentPanel).parent().css("padding-bottom", newPadding);
		}else{
			$(currentPanel).parent().css("padding-bottom", 0);
		}
	}

	$('.tabSlider').on('slide.bs.carousel', function (e) {
		var currentItemTo = $(e.relatedTarget).attr('data-item-no');
		var parentId = $(this).data("parentId");
		var panelCt = $("#"+parentId)[0];
		window.location.hash = parentId + "&" + currentItemTo;
	})

	$('.tabSlider').on('slid.bs.carousel', function (e) {
		var parentId = $(this).data("parentId");
		var panelCt = $("#"+parentId)[0];
		setPadding(panelCt);
		panelCt.scrollIntoView({block: "start", behavior: "smooth"});
	})

	$(window).scroll(function() {
		checkPanelsPosition();
	});

	function checkPanelsPosition(){
		var openPanels = $(".panel:has(.panel-collapse[aria-expanded='true'])");
		if(openPanels.length > 0 && !$(openPanels).parents('.ncsatzCollapsible').length){
			for(var i = 0; i < openPanels.length; i++){
				var openPanel = openPanels[i];
				var stickyPanel = $(openPanel).offset();
				var panelHeader = $(openPanel).find(".panel-heading")[0];

				if((stickyPanel.top - 35) > ($(window).scrollTop() - $(openPanel).height())){
					if ($(window).scrollTop() > stickyPanel.top - 35) {

						$(openPanel).addClass("floating");
					}else{
						$(openPanel).removeClass("floating");
					}
					if ($(window).scrollTop() > stickyPanel.top) {
						$(panelHeader).css("top", $(window).scrollTop() - stickyPanel.top );
					}else{
						$(panelHeader).css("top",0);
					}
				}else{
					$(openPanel).removeClass("floating");
					$(panelHeader).css("top",0);
				}
			}
		}
	}

	$('a[data-toggle="tab"][data-is-collapse-tab="true"]').on('click', function (e) {
		e.preventDefault();
		var parentId = $(this).data("parentId");
		var ariaControls = this.getAttribute("aria-controls");
		var linkTab = $("#" + parentId + "-tabs").find(".nav-tabs").find('a[aria-controls="'+ariaControls+'"]');
		var isResponsive = $(this).data('isResponsiveTab');
		var tabsID = "#" + parentId + "-tabs";
		if(isResponsive && linkTab.length > 0 && linkTab.parent().hasClass("active")) {
			var currentArea = e.target.getAttribute("aria-controls");
			var contentElem = $(tabsID);
			contentElem.find(".tab-content").find(".panel-heading").removeClass("active");
			contentElem.find(".tab-content").find(".tab-pane").removeClass("active");
			linkTab.parent().removeClass("active");
			return false;
		}
		if(linkTab.length > 0)
			$(linkTab).trigger('click');
	});
	$('a[data-toggle="tab"]').on('show.bs.tab', function (e) {
	});
	$('a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
		var isResponsive = $(this).data('isResponsiveTab');
		var blockId = $(this).data('blockId');
		var parentId = $(this).data('parentId');
		var tabsID = "#" + parentId + "-tabs";
		window.location.hash="";

		if(isResponsive){
			refreshActiveTabs(e, tabsID);
		}

		checkTimer(blockId);
	});

	//This event is for when the infoButton is clicked and a modal with a backdrop is fired
	$(".infoButton").on('click', function (){
		//THIS LINE FIXES THE BOOTSTRAP ISSUE WHERE THE BACKDROP COVERS THE MODAL
		$('body .modal-backdrop').addClass("infoBackdrop").css({
			display:"block !important"
		})
	})
	//This event remove the "milky white" cover in front of the test once the timer has started
	$(".time_popup_strat_time").on('click', function(){
		$(".cover-ct").remove()
	})

	$('.info-popup').on('show.bs.modal', function () {
		$('body .modal-backdrop').show();
		var backdrop = document.createElement("div");
		backdrop.classList.add("modal-backdrop");
		$(this).insertBefore(backdrop);
	});
	$('.info-popup').on('shown.bs.modal', function () {
		$('body .modal-backdrop').show();
	});
	$('.info-popup').on('hidden.bs.modal', function () {
		$('body .modal-backdrop').remove();
	});
	$('.timer_modal').on('hidden.bs.modal', function () {
		var clock = $(this).data('clock');
		var blockType = clock.data('blockType');
		var blockId = clock.data('blockId');

		if(clock.length){
			var clockCt = clock.parent();
			var testCt = $("#"+blockId);
			var blockHeader = $(testCt).find("header");
			if(blockHeader.length > 0){
				$(clockCt).detach().insertAfter(blockHeader);
			}else{
				$(clockCt).detach().prependTo(testCt);
			}

			clockCt.show();
			if(blockType=="test"){
				clock.children(".countDownCt").countdown({until: $(this).data("countDownTimer"),format:'MS',layout: '{mnn}{sep}{snn}',onExpiry: function(){
						timeOff(clock);
					}});
				window.isTesting = true;
			}else{
				clock.children(".countDownCt").countdown({since: $(this).data("countDownTimer"),format:'MS',layout: '{mnn}{sep}{snn}'});
			}
			clock.addClass("play");
			$("#"+blockId+"-cover-ct").hide();
			$(this).data('ejecuted',true);
		}
	});
	$('.question_modal').on('hidden.bs.modal', function () {
		var clock = $(this).data('clock');
		var blockType = clock.data('blockType');
		var blockId = clock.data('blockId');

		if(clock.length){
			clock.show();
			if(blockType=="test"){
				clock.children(".countDownCt").countdown({until: $(this).data("countDownTimer"),format:'MS',layout: '{mnn}{sep}{snn}',onExpiry: function(){
						timeOff(clock);
					}});
				window.isTesting = true;
			}else{
				clock.children(".countDownCt").countdown({since: $(this).data("countDownTimer"),format:'MS',layout: '{mnn}{sep}{snn}'});
			}
			clock.addClass("play");
			$("#"+blockId+"-cover-ct").hide();
			$(this).data('ejecuted',true);
		}
	});


	function checkTimer(blockId, moveClock, topDistance) {
		var panel = $("#"+blockId);
		var useTimer = panel.data('useTimer');
		var blockType = panel.data('blockType');
		var maxTime = panel.data('maxTime');
		var wrongTrials = panel.data('wrongTrials');
		var grade = panel.data('grade');
		var clock = $('#clock');
		clock.parent().hide();
		clock.data("testObject",null);
		clock.data("blockId",blockId);
		clock.data("blockType",blockType);
		clock.data("wrongTrials",wrongTrials);
		clock.data("grade",grade);
		clock.children(".countDownCt").countdown('destroy');
		clock.removeClass("block-training");
		clock.removeClass("block-test");
		clock.removeClass("stoped");
		clock.addClass("block-"+blockType);

		var currentDate = new Date();
		var countModal = $("#"+blockId+"-timer-modal");
		if (typeof SCOasBrowse !== 'undefined' && SCOasBrowse()){
			countModal.data('ejecuted',true);
		}
		var animationEjecuted = countModal.data('ejecuted');

		if(useTimer && !animationEjecuted){
			$("#"+blockId+"-show-time").html(maxTime);
			var countDownTimer = panel.data('countDownTimer');
			countModal.data("clock",clock);
			countModal.data("countDownTimer",countDownTimer);
			countModal.modal("show");
			$("#"+blockId+"-cover-ct").show();
			/*if(moveClock)
				clock.css('top',topDistance + 'px')*/
		}else if(useTimer && animationEjecuted){
			$("#"+blockId+"-cover-ct").show();
		}else{
			$("#"+blockId+"-cover-ct").hide();
		}
	};

	function timeOff(clock) {
		showFeedback(clock,true);
		//interactionEnd();
	};

	$('#clock .play_ico').click(function(e){
		var clock = $(this).parent();
		clock.children(".countDownCt").countdown('resume');
		clock.toggleClass("pause");
		clock.toggleClass("play");
		var blockId = clock.data("blockId");
		$("#"+blockId+"-cover-ct").hide();
	});

	$('#clock .pause_ico').click(function(e){
		var clock = $(this).parent();
		clock.children(".countDownCt").countdown('pause');
		clock.toggleClass("pause");
		clock.toggleClass("play");
		var blockId = clock.data("blockId");
		$("#"+blockId+"-cover-ct").show();
	});

	$('#clock .stop_ico').click(function(e){
		var clock = $(this).parent();
		var blockId = clock.data("blockId");
		$("#"+blockId+"-cover-ct").show();
		//interactionEnd();
		showFeedback(clock);
	});



	$('#clock .clock_ico').click(function(e){
		$(this).parent().parent().toggleClass("hiddenClock");
	});

	function refreshActiveTabs(e, tabsID){
		var contentElem = $(tabsID);
		contentElem.children("tab-content").children("panel-heading").removeClass("active");
		var parentElem = $(e.target).parent().parent().addClass("active");
	}
	$('#sidebar-nav-collapse').on('show.bs.collapse', function () {
		$(".sidebarOverlay").show();
		window.sidebarOverlayVisible = true;
	});

	$('#sidebar-nav-collapse').on('hidden.bs.collapse', function () {
		$(".sidebarOverlay").hide();
		window.sidebarOverlayVisible = false;
	});

	$('.panel-group .panel-collapse.in').prev().addClass('active');
	$('.panel-group')
		.on('show.bs.collapse', function(e) {
			if(!allExpanded)
				e.stopPropagation();

			$(e.target).prev('.panel-heading').addClass('active');
		})
		.on('hide.bs.collapse', function(e) {
			if(!allExpanded)
				e.stopPropagation();

			$(e.target).prev('.panel-heading').removeClass('active');
		});

	$(".carousel").on("slide.bs.carousel", function(e) {
		var slideID = $(this).attr('id');
		var controls = $('[href="#' + slideID + '"], [data-target="#' + slideID + '"]');
		var activeClass = 'active';
		var currentItemTo = $(e.relatedTarget).attr('data-item-no');
		$("#"+slideID).children('.carousel-pagination').children('.carousel-pagination-number-start').html(Number(currentItemTo) + 1);
	});

	$(".carousel").swipe({
		swipe: function(event, direction, distance, duration, fingerCount, fingerData) {
			if (direction == 'left') $(this).carousel('next');
			if (direction == 'right') $(this).carousel('prev');
		},
		allowPageScroll:"vertical"
	});

	activateTabs(isTab, isCollapse);

	if(isContent){
		checkTimer(blockId);
	}

	$(window).bind('hashchange', function() {
		activateTabs(isTab, isCollapse);
	});

	function activateTabs(isTab, isCollapse){
		if(Smc.SectionVariables.variableValues.isOnlineHelp != 'true'){
			var currentHash = window.location.hash;
			var tabId = currentHash.split("#", 2);
			var activeCarousel = 0;
			if(tabId[1] != undefined){

				var currentTabId = tabId[1];

				if(currentTabId.indexOf("&") > -1){
					var splittedTabId = currentTabId.split("&");
					currentTabId = splittedTabId[0];
					activeCarousel = splittedTabId[1];
				}

				var referencedElem = $("#" + currentTabId);

				if(isTab){
					$("a[aria-controls=main-content-"+currentTabId+"]").trigger('click');
				}else if(isCollapse && $("a[aria-controls=collapsible-"+currentTabId+"]").length > 0){

					var isExpanded = $("a[aria-controls=collapsible-"+currentTabId+"]")[0].getAttribute("aria-expanded") == "true";

					referencedElem.data("slideStart",activeCarousel);

					if(!isExpanded) {
						$("a[aria-controls=collapsible-" + currentTabId + "]").trigger('click');
						// $("a[data-collapsible-id=collapsible-" + currentTabId + "]").parent().addClass('active');
					}else{
						$("#carousel-" + currentTabId + "-tab").carousel(Number(activeCarousel));
					}
				}else if(isCollapse && referencedElem){

					var parentCloseHeader = $(referencedElem).parents(".panel").children(".panel-heading:not(.active)")[0];
					var parentPanelId = $(parentCloseHeader).parent('.panel').data('panelId');
					$("a[aria-controls=collapsible-" + parentPanelId + "]").trigger('click');
				}

			}
		}
	}

	window.interactionEnd = function interactionEnd(testObject){
		var clock = $('#clock');
		clock.data("testObject",testObject);
		var wrongTrials = clock.data("wrongTrials");
		if((testObject.finished || (wrongTrials && testObject.errorCount == wrongTrials)) ||
			(testObject.excerciseFinished && testObject.finished)
		){
			showFeedback(clock);
			if (!testObject.excerciseFinished){
				// if break simulation (testObject.errorCount == wrongTrials)
				setScormScore(clock);
			}
		}
		if(testObject.excerciseFinished){
			clock.children(".countDownCt").countdown('pause');
			clock.addClass("stoped");
			setScormScore(clock);
			window.isTesting = false;
		}
	}

	window.showFeedback = function (clock, timeOff) {
		//clock.hide();
		//clock.children(".countDownCt").countdown('destroy');
		window.isTesting = false;
		clock.children(".countDownCt").countdown('pause');
		clock.addClass("stoped");
		var blockId = clock.data('blockId');
		var panel = $("#" + blockId);
		$("#"+blockId+"-cover-ct").show();
		var currentFeedback = null;
		var feedbackDefault = panel.find(".feedback[data-is-default='true']")[0];
		var feedbackTimeOff = panel.find(".feedback[data-to-include='true']")[0];
		var testObject = clock.data("testObject");
		var blockType = clock.data('blockType');
		var feedbackModal = $("#"+blockId+"-modal-feedback");

		var parentBlock = panel.parents("*[data-block-id='"+blockId+"']");

		if(testObject != null){
			var feedbacks = panel.children(".feedback[data-is-default!='true'][data-to-include!='true']");
			var totalWrongs = testObject.errorCount;
			for (var i = 0; i < feedbacks.length; i++) {
				var feedback = feedbacks[i];
				var currentWrongs = $(currentFeedback).data("wrongTrials") ? $(currentFeedback).data("wrongTrials") : null;
				if($(feedback).data("wrongTrials") >= totalWrongs && (currentWrongs == null || $(feedback).data("wrongTrials") <= currentWrongs) ){
					currentFeedback = feedback;
					if ($(feedback).data("wrongTrials") === totalWrongs) {
						break;
					}
				}
			}
		}
		if(!timeOff){
			if(currentFeedback != null){
				showFeedBack(currentFeedback);
			}else if(feedbackDefault != undefined){
				showFeedBack(feedbackDefault);
			}
		}else if(feedbackTimeOff != undefined ){
			showFeedBack(feedbackTimeOff);
		}
		function showFeedBack(feedBack){
			$("#"+blockId+"-feedback-msg").html($(feedBack).html());
			//if(blockType!="test" || !(APIOK && APIOK())){ // check if Scorm API is out because scorm only score/grade only once.
			var button = $("#"+blockId+"-button-test-reload");
			button.click(function() {
				window.location.reload(false);
			});
			$(button).detach().appendTo("#"+blockId+"-feedback-msg");
			//}
			feedbackModal.modal("show");

			if(parentBlock.length > 0){
				parentBlock[0].scrollIntoView();
			}else{
				panel[0].scrollIntoView();
			}
		}
	};

	window.setScormScore = function (clock) {
		var currentFeedback = null;
		var blockId = clock.data('blockId');
		var panel = $("#" + blockId);
		var testObject = clock.data("testObject");
		if(testObject != null){
			var feedbacks = panel.children(".feedback[data-is-default!='true'][data-to-include!='true']");
			var totalWrongs = testObject.errorCount;
			for (var i = 0; i < feedbacks.length; i++) {
				var feedback = feedbacks[i];
				var currentWrongs = $(currentFeedback).data("wrongTrials") ? $(currentFeedback).data("wrongTrials") : null;
				if($(feedback).data("wrongTrials") >= totalWrongs && (currentWrongs == null || $(feedback).data("wrongTrials") <= currentWrongs) ){
					currentFeedback = feedback;
					if ($(feedback).data("wrongTrials") === totalWrongs) {
						break;
					}
				}
			}
		}
		if (SCOSetScore){
			SCOSetScore(blockId, $(currentFeedback).data("grade"));
		}
	};

	window.checkIframesSize = function (resizeFunction, iframe, browser) {

		var checkIframesSize = function () {
			var iframeWin = iframe.contentWindow || iframe.contentDocument;
			if (iframeWin && iframeWin.document.body) {
				var bodyCurrentHeight = iframeWin.document.documentElement.offsetHeight;
				var frameId = iframe.getAttribute("class");
				var bodyOldHeight = window.iframeLastHeight && window.iframeLastHeight[frameId] ? window.iframeLastHeight[frameId] : 0;
				var diff = Math.abs(bodyCurrentHeight - bodyOldHeight);
				if (diff > 10){
					resizeFunction(iframe);
					window.iframeLastHeight[frameId] = bodyCurrentHeight;
				}
			}
			setTimeout(checkIframesSize, 100);
		};

		checkIframesSize();
	};

	window.iframeLoad = function (resizeFunction, iframe,browser) {
		$(iframe).on('load', function() {
			this.height='';
		});
	};

	var parseQueryString = function(queryString) {
		var params = new Object();
		if (queryString == null)
			return params;
		if (queryString.substring(0, 1) == "?")
			queryString = queryString.substring(1);

		var paramsArr = queryString.split("&");
		for (var i = 0; i < paramsArr.length; i++)
		{
			var item = paramsArr[i];
			var pos = item.indexOf("=");
			if (pos > -1)
			{
				var arr = item.split("=");
				params[arr[0]] = decodeURIComponent(arr[1]);
			}
			else
				params[item] = "";
		}
		return params;
	};

	var p = parseQueryString(location.search);
	if (p['highlight']){
		$(".column-main").SearchHighlight({
			exact: "partial",
			style_name: "highlight",
			style_name_suffix: false,
			keys: p['highlight'],
			highlight: ".column-main"
		});
	}
	var queryString = window.location.search;
	var urlParams = new URLSearchParams(queryString);
	var expandAllPanels = urlParams.get('expand') == 'true';

	if(expandAllPanels){
		allExpanded = true;
		var closeLink = $('.closeTabs');
		var accordionId = closeLink.data("accordionId");
		if(accordionId != undefined){
			openAllPanels(accordionId);
			closeLink.addClass('opened');
			closeLink.removeClass('closed');
		}
	}

	$(".copyBtn").click(function(e){
		var copyBtn = this;
		e.stopPropagation();
		e.preventDefault();
		var copyTarget = $(this).data("copyTarget");
		$(this).addClass("active");
		setTimeout(function () {
			$(copyBtn).removeClass("active");
		}, 1000);

		var contentNotice = $("#" + copyTarget)[0];

		if (window.getSelection) {
			if (window.getSelection().empty) { // Chrome
				window.getSelection().empty();
			} else if (window.getSelection().removeAllRanges) { // Firefox
				window.getSelection().removeAllRanges();
			}
		} else if (document.selection) { // IE?
			document.selection.empty();
		}

		if (document.selection) {
			var range = document.body.createTextRange();
			if($(contentNotice).is(":visible")){
				range.moveToElementText(contentNotice);
				range.select().createTextRange();
				document.execCommand("copy");
			}else{
				$(contentNotice).show();
				range.moveToElementText(contentNotice);
				range.select().createTextRange();
				document.execCommand("copy");
				$(contentNotice).hide();
			}
		} else if (window.getSelection) {
			var range = document.createRange();
			if($(contentNotice).is(":visible")) {
				range.selectNode(contentNotice);
				window.getSelection().addRange(range);
				document.execCommand("copy");
			}else{
				$(contentNotice).show();
				range.selectNode(contentNotice);
				window.getSelection().addRange(range);
				document.execCommand("copy");
				$(contentNotice).hide();
			}
		}

		window.getSelection().removeAllRanges();

	});
	Smc.customInitExecuted = true;
};

function customMaxHeightForMedia() {
	var videoElements = document.querySelector("video[customheight]");
	if (videoElements) {
		var containers = document.getElementsByClassName("mejs__container");
		var maxHeightAttribute = videoElements.getAttribute("customheight");
		if (maxHeightAttribute) {
			var maxHeight = "max-height:" + maxHeightAttribute.substring(maxHeightAttribute.lastIndexOf('-') + 1, maxHeightAttribute.length) + "px;";
			for (var i = 0; i < containers.length; i++) {
				containers[i].setAttribute("style", maxHeight);
			}
		}
	}
}

function handledLinksxRef() {
	var links = document.getElementsByTagName("a");
	if(links) {
		for(var i = 0; i< links.length; i++) {
			var href = links[i].href;
			if(href && href.includes("undefined")) {
				links[i].textContent = "-";
				links[i].classList.add("inactive-link");
			}
		}
	}
}

$(document).ready(function (){
	if(!Smc.customInitExecuted){
		Smc.customInit();
	}
});