function checkTitlepageSize(){
	var titlepage = $('.childBlock.titlepage');
	if(titlepage.length > 0) {
		var titlepageImg = titlepage.find('img');
		if(titlepageImg.length > 0){
			var titlepageImgW = titlepageImg[0].clientWidth;
			titlepage.find('.childBlockCt ').outerWidth(titlepageImgW);
		}
	}
}

$(window).resize(function(){
	if (window.resizeTimeoutHandler) {
		clearTimeout(window.resizeTimeoutHandler);
		window.resizeTimeoutHandler = null;
	}
	window.resizeTimeoutHandler = setTimeout(checkTitlepageSize, 200);
});

window.initCallback = function(){
	tabPanel = Smc.System.GUI.getGuiObject("sidebarTabs");
	tabPanel.setActiveTab(0);
	
	var sidebarPanel = Smc.System.GUI.getGuiObject("smc-sidebar");
	sidebarPanel.on("collapse", checkTitlepageSize);
	sidebarPanel.on("expand", checkTitlepageSize);

	var groupOptions = Smc.System.GUI.getGuiObject("smc.search.options");
	if (groupOptions) {
		var searchDiv = document.createElement("div");
		searchDiv.setAttribute("class","content-search-jh");

		var inputButton = document.createElement("input");
		inputButton.setAttribute("class","fuzzyComplete x-form-trigger-wrap-default");
		inputButton.setAttribute("id","smc-search-field");
		inputButton.setAttribute("type","text");
		inputButton.setAttribute("autocomplete","off");
		$(inputButton).keydown(function(e){
			var id = event.which || event.keyCode || 0;
            if (id == 13) {
               Smc.System.doCustomSearch();
            }
		});

		$($(groupOptions.body.dom).children()[0]).children()[0].appendChild(inputButton);
   	}
}

$(function() {
	Smc.System.setActiveTab = function () {
	}
	Smc.System.processResponseOpenPage = function (response) {
		if (response) {
			var ownerDocument = document.implementation.createHTMLDocument('virtual');
			var jEl = $(response, ownerDocument);
			var contentBody = jEl.filter("div,section");
			var titleNode = jEl.filter("title");
			var contentBodyHtml = '';
			for (var i = 0; i < contentBody.length; i++) {
				contentBodyHtml += contentBody[i].outerHTML;
			}
			var info = {
				body: contentBodyHtml,
				title: typeof (titleNode.text) === "function" ? titleNode.text() : titleNode.text
			};
			return info;
		}
	}

	Smc.System.onSuccessPage = function (node, panel, title, response) {
		var info = this.processResponseOpenPage(response);
		title = (title && title.length > 0) ? title : info["title"];
		var path = panel.currentPath;
		panel.update(info["body"]);
		panel.setTitle(title);

		if (path.indexOf("#") !== -1) {
			var anchorId = path.slice(path.indexOf("#"));
			var targetSection = $(anchorId);
			if (targetSection.length > 0) {
				setTimeout(function () {
					if (targetSection.get(0)) {
						targetSection.get(0).scrollIntoView();
					}
				}, 100);
			}
		}else{
			setTimeout(function () {
				panel.scrollTo(0,0,false);
			}, 100);
		}

		if (node.attributes) {

			if (node.attributes.path != null && node.attributes.path.indexOf("#") > -1) {
				var anchor = node.attributes.path.split("#")[1];
				var elem = $("#" + anchor);
				setTimeout(function () {
					if (elem.get(0)) {
						elem.get(0).scrollIntoView();
					}
				}, 100);
			}

			if (node.attributes["searchField"]) {
				var doc = panel.body.dom.querySelector("div.x-autocontainer-innerCt");
				var phrase = node.attributes.searchField.replace(/^\s+|\s+$/g, "").replace(/\s+/g, "|");
				Smc.System.highlightInElement(doc, phrase);
			}
		}

		var params = Util.parseQueryString(window.location.search);
		if (params["scrollTo"]) {
			var scrollElem = $("#" + params["scrollTo"]);
			if (scrollElem.get(0)) {
				scrollElem.get(0).scrollIntoView();
			} else {
				var url = window.location.href;
				var scrollParam = url.split('?')[1];
				if (window.location.protocol !== "file:") {
					history.pushState({}, null, './');
				}
				window.location.hash = scrollParam.split('#')[1];
			}
		}

		this.runQuery(panel.body.dom, "img[src^='../'],source[src^='../'],track[src^='../']", this.adapterRootImg, this);
		this.runQuery(panel.body.dom, "a[class*='link-file'],a[class*='preview-image']", this.adapterRootLink, this);
		this.runQuery(panel.body.dom, "a[class*='link-xref']:not([class*='arrow'])," +
			" a[class*='link-detail']," +
			" a[class*='link-element']," +
			" area[class*='link-xref']," +
			" div[class*='index'] a", this.asignLinkEvent, this);
		this.runQuery(panel.body.dom, "div[class*='container-navButtons'] a[class*='smc-print']", this.asignPrintEvent, this, {path: path});
		this.runQuery(panel.body.dom, "a[class*='preview-image']", this.asignMediaPreviewEvent, this);
		this.runQuery(panel.body.dom, "iframe[class*='edge-frame']", this.processEdgeFrames, this);

		this.runQuery(panel.body.dom, "video", this.asignVideoEvent, this);

		var arrowsNav = $(panel.body.dom).find("#navArrows");
		var breadCrumb = $(panel.body.dom).find(".breadcrumbHelp");
		var mainPanel = Smc.System.GUI.getGuiObject("smc-content-preview");
		var divContainer = document.createElement("div");
		divContainer.appendChild(arrowsNav[0]);
		if (breadCrumb[0]) {
				var childsLi = breadCrumb[0].getElementsByTagName("li");
				if (childsLi.length > 4) {
					for (var i = 0; i < childsLi.length; i++) {
						if (childsLi.length > 4) {
							childsLi[i].remove();
						}
					}
					childsLi[0].firstChild.remove();
					childsLi[0].textContent = "...";
				}
				divContainer.appendChild(breadCrumb[0]);
			}
		mainPanel.header.setHtml(divContainer.outerHTML);
		this.runQuery(mainPanel.header.el.dom, "a.link-xref:not([class*='smc-print'])", this.asignLinkEvent, this);
		arrowsNav.remove();
		if(breadCrumb) {
			breadCrumb.remove();
		}

		if (Smc.customInit) {
			Smc.customInitExecuted = false;
			Smc.customInit();
		}
	}
	Smc.System.processEdgeFrames = function (iframe) {
		if (iframe) {
			var iframeSrc = iframe.getAttribute("src");
			if(iframeSrc.indexOf("?") !== -1){
				iframeSrc = iframeSrc.split("?");
				iframe.setAttribute("src", this.splitPrefix(iframeSrc[0])+"?"+iframeSrc[1]);
			}else{
				iframe.setAttribute("src", this.splitPrefix(iframeSrc));
			}

			// fire iframe resize when window is resized
			var windowResizeFunction = function (resizeFunction, iframe) {
				$(window).resize(function () {
					resizeFunction(iframe);
				});
			};
			// fire iframe resize when iframe body is resized
			var bodyResize = function (resizeFunction, iframe) {
				var iframeWin = iframe.contentWindow;
				var bodyEl = $(iframeWin.document.body);
				$(bodyEl).resize(function () {
					resizeFunction(iframe);
				});
			};
			var calc = function (iframe, $iframeBody, options, browser) {
				// since the jquery browser is passed in you can also check specific versions if desired

				var height = 0;
				if (iframe.contentDocument && iframe.contentDocument.documentElement) {
					height = iframe.contentDocument.documentElement.offsetHeight;
				}

				if (height == 0) {
					$iframeBody.children("*").each(function () {
						var elHeight = $(this).height();
						if (elHeight > height) {
							height = elHeight;
						}
						$(this).children("*").each(function () {
							elHeight = $(this).height();
							if (elHeight > height) {
								height = elHeight;
							}
						});
					});
				}

				return height + options.heightOffset;
			};
			$(iframe).iframeAutoHeight({
				debug: true,
				minHeight: 180,
				diagnostics: true,
				heightOffset: 10,
				heightCalculationOverrides: [{
					browser: 'webkit',
					calculation: calc
				}, {
					browser: 'mozilla',
					calculation: calc
				}, {
					browser: 'msie',
					calculation: calc
				}, {
					browser: 'opera',
					calculation: calc
				}, {
					browser: 'chrome',
					calculation: calc
				}, {
					browser: 'default',
					calculation: calc
				}],
				triggerFunctions: [bodyResize,
					windowResizeFunction,
					iframeLoad,
					checkIframesSize]
			});
		}
	};
	Smc.System.asignLinkEvent = function (link) {
		if (link) {
			link.setAttribute("href", "#" + this.splitPrefix(link.getAttribute("href")));

			link.addEventListener("click", function (e) {
				e.preventDefault();

				Smc.System.openPage({
					attributes: {
						path: e.currentTarget.getAttribute("href"),
						text: e.currentTarget.text
					}
				}, false, true);
			}, this);
		}
	};
	Smc.System.doCustomSearch = function () {
        var searchField = Smc.System.GUI.getGuiObject("smc-search-field");
        if (!searchField) {
        	searchField = $("#smc-search-field")[0].value;
        } else {
            searchField = searchField.value;
        }

        var resultCt = Smc.System.GUI.getGuiObject("smc-content-preview-search");

        var searchID = Smc.System.getTranslatorCtrl().t("smc.search");

        /* Sanitize Input */
        searchField = searchField
        	.replace(/&/g, '&amp;')
            .replace(/</g, '&lt;')
            .replace(/>/g, '&gt;')
            .replace(/"/g, '&quot;')
            .replace(/'/g, '&#x27;')
            .replace(/\//g, '&#x2F;')
            .replace(/`/g, '&#x60;')
            .replace(/=/g, '&#x3D;');

       	resultCt.setTitle(searchID + ": " + searchField);

        if (searchField) {
        	switch( Smc.System.getOnlineHelpType() ){
            	case "auto":
            		if(window.location.protocol == "file:"){
            			Smc.System.doLocalSearch(searchField, resultCt);
            		}else{
            			Smc.System.doLuceneSearch(searchField, resultCt);
            		}
            		break;
            	case "jsonly":
            		Smc.System.doLocalSearch(searchField, resultCt);
            		break;
            	case "lucene":
            		Smc.System.doLuceneSearch(searchField, resultCt);
            		break;
            	case "lucene-php":
            		Smc.System.doLuceneSearch(searchField, resultCt, "php");
            		break;
            	default:
            		Smc.System.doLocalSearch(searchField, resultCt);
            		break;

         	}
        }
        resultCt.setVisible(true);
		Smc.System.addLastSearch();
	};
	Smc.System.addLastSearch = function () {
		var searchValue = Smc.System.GUI.getGuiObject("smc-search-field");
		if (!searchValue) {
			searchValue = $("#smc-search-field")[0].value;
		} else {
			searchValue = searchValue.value;
		}
		if (!Smc.System.lastSearch) {
			Smc.System.lastSearch = [];
			Smc.System.lastSearch.push(searchValue);
		} else if (Smc.System.lastSearch.indexOf(searchValue) === -1) {
			var lastSearch = [];
			lastSearch.push(searchValue);
			if (Smc.System.lastSearch[0]) {
				lastSearch.push(Smc.System.lastSearch[0]);
			}
			if (Smc.System.lastSearch[1]) {
				lastSearch.push(Smc.System.lastSearch[1]);
			}
			Smc.System.lastSearch = lastSearch;
		}
		var html = "";
		var container = Smc.System.GUI.getGuiObject("smc-search-results");
		var searchLink = Smc.System.lastSearch;
		for (var i = 0; i < searchLink.length; i++) {
			var current = searchLink[i];
			html += '<a class="last-search-item" id="last-search-'+ i +'">'+ current +'</a>';
		}
		container.update(html);
		if (!container.isVisible()) {
			container.setVisible(true);
		}
		$(".last-search-item", container.body.dom).click(function (e) {
			e.stopPropagation();
			Smc.System.doReSearch(e.currentTarget.text);
		});
	};
	Smc.System.doReSearch = function (value) {
		$("#smc-search-field").val(value);
		Smc.System.doCustomSearch();
	};
	Smc.System.onCustomPressSearchFieldKey = function(field, e) {
		if (e.getKey() == e.ENTER) {
			Smc.System.doCustomSearch();
			return false;
		}
	};
	Smc.System.doLocalSearch = function(searchField, resultCt){

    	var specialChars = /(\s)?[`~!@#$%^&*()_|+\-=?;:'",.<>\{\}\[\]\\\/](\s)?/gi;

    	var searchFieldValue = searchField.split(" ");
    	for(var word=0; word < searchFieldValue.length; word++){
    		searchFieldValue[word] = searchFieldValue[word].replace(specialChars,"");
    		if( !searchFieldValue[word] ){
    			searchFieldValue.splice(word, 1);
    		}
    	}
    	if (searchField.indexOf("-") > -1) {
    		searchFieldValue = searchField.split("-");
    		searchFieldValue = searchFieldValue.concat(searchField);
    	}
    	searchFieldValue = searchFieldValue.join("+");

    	var container = $(resultCt.body.dom);

    	container.empty();

    	Smc.XSearch.init(container.attr("id"), resultCt.config.title, "N�chste Seite", "Vorige Seite", searchFieldValue);

    	this.filterSearchByBook(container, searchFieldValue);

    	var anchorLink = container.find("a");

    	$.each(anchorLink, function (index, value){
			var anchor = $(anchorLink[index]);
			var newPath = anchor.attr("href");
    		newPath = "#" + Smc.System.splitPrefix(newPath);
    		anchor.attr("href", newPath);

    		anchor.on('click', function(event) {
				event.preventDefault();
    			var path = anchor.attr("href");
				if (path.indexOf("#") == 0) {
    				path = path.substring(1);
    			}

    			Smc.System.openPage({
    				attributes: {
    					path: path,
    					text: $(this).text(),
    					searchField: searchField
    				}
    			}, false, true, null, null);

    			return false;
    		});
    	});
    }
});